/* test_timer.c
 *
 * Autor: gkemnitz
 * letzte Änderung: 30.10.2015
 *
 * Experimentierprogramm zum Ausprobieren
 * unterschiedlicher Timer-Modi
 *
 * LED-Modul an Port C
*/ 


#include <avr/io.h>


// Experiment: Normalmodus, 2 Hz LED-Zähler
#include <avr/io.h>
int main(void){
  TCCR3A = 0;               // WGM3[1:0] = 0
  TCCR3B = 0b011;           // WGM3[3:2] = 0, CS3=0b011
  DDRJ = 0xFF;
  while(1){
    if (TIFR3 & (1<<TOV3)){ // Warte auf Überlauf
      PORTJ++;              // Erhöhe LED-Ausgabe
      TIFR3 = (1<<TOV3);    // Lösche Überlaufbit
    }
  }
}



/* 
// Experiment CTC-Modus
// Schaltermodul an JA oben
#include <avr/io.h>
int main(void){
  TCCR3A = 0;        // WGM3[1:0] = 0
  TCCR3B = 0b1101;   // WGM3[3:2] = 1, CS3=0b101
  DDRJ = 0xFF;
  OCR3A = (1<<(PINA&0xF))+8; // Vergleichswert
  while(1){
    if (TIFR3 & (1<<OCF3A)){// Warte auf Gleichheit
      PORTJ++;              // Erhöhe LED-Ausgabe
      TIFR3 = (1<<OCF3A);   // Lösche Vergleichsbit
      OCR3A = (1<<(PINA&0xF))+8;// neuer Vgl.-Wert
    }
  }
}
*/


/*
// Experiment PWM-Ausgabe
// LED-Modul an JE
int main(void){
  TCCR3A = 0b10<<COM3B0 | 0b10<<COM3C0 | 0b11; 
  TCCR3B = 0b11101;    // WGM3[3:2] = 0b11, CS3=0b100
  OCR3A  = 0x8000;     // Zählperiode
  OCR3B  = 0x2000;     // PE4 ein nach 25% Periode
  OCR3C  = 0x4000;     // PE5 ein nach 50% Periode
  DDRE = 0x30;         // PWM-Ausgänge PE4, PE5
  while(1){
    if (TIFR3 & (1<<OCF3A)) 
      TIFR3 = (1<<OCF3A);
    if (TIFR3 & (1<<OCF3B))
      TIFR3 = (1<<OCF3B);
    if (TIFR3 & (1<<OCF3C))
      TIFR3 = (1<<OCF3C);
  }
}
*/

